<?php

namespace Drupal\hidden_tab\Event;

use Drupal\hidden_tab\Entity\HiddenTabPageInterface;
use Symfony\Component\EventDispatcher\Event;

/**
 * The event published when a new mail is sent by mailer (after it is sent).
 */
class HiddenTabAfterMailEvent extends Event {

  /**
   * Name of this event.
   */
  const EVENT_NAME = 'HIDDEN_TAB_AFTER_MAIL_EVENT';

  /**
   * The page entity being created (might not have been saved yet).
   *
   * @var \Drupal\hidden_tab\Entity\HiddenTabPageInterface
   */
  public $page;

  /**
   * HiddenTabPageFormEvent constructor.
   *
   * @param \Drupal\hidden_tab\Entity\HiddenTabPageInterface $page
   *   See $this->page.
   */
  public function __construct(HiddenTabPageInterface $page) {
    $this->page = $page;
  }

}
