<?php

namespace Drupal\hidden_tab\EventSubscriber;

use Drupal\Core\Datetime\DateFormatterInterface;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\StringTranslation\TranslationInterface;
use Drupal\hidden_tab\Entity\HiddenTabMailerListBuilder;
use Symfony\Component\HttpFoundation\RequestStack;

/**
 * To list all entities of the page, on it's edit form.
 */
class HiddenTabPageFormSubscriberForMailerList extends ForEntityListFormBase {

  /**
   * {@inheritdoc}
   */
  protected $prefix = 'hidden_tab_list_of_mailers_form_subscriber_0__';

  /**
   * {@inheritdoc}
   */
  protected $entityType = 'hidden_tab_mailer';

  /**
   * {@inheritdoc}
   */
  protected $label = 'Mailers';

  /**
   * @var \Drupal\Core\Datetime\DateFormatterInterface
   */
  protected $df;

  public function __construct(TranslationInterface $t,
                              EntityTypeManagerInterface $em,
                              RequestStack $request_stack,
                              DateFormatterInterface $df) {
    parent::__construct($t, $em, $request_stack);
    $this->df = $df;
  }

  /**
   * {@inheritdoc}
   */
  protected function header(): array {
    return HiddenTabMailerListBuilder::header();
  }

  /**
   * {@inheritdoc}
   */
  protected function row(EntityInterface $entity): array {
    /** @noinspection PhpParamsInspection */
    return HiddenTabMailerListBuilder::row($this->df, $entity);
  }

}
